import { type ValidationArgs } from "@vuelidate/core";
import { type Component } from "vue";
export type FormElementDataType<T> = T | T[];
export interface FormElementItem {
    key: string;
    props: <T>() => T;
    formFieldProps?: <T>() => T;
    validation?: <T>(model: FormElementDataType<T>) => ValidationArgs;
    formFieldComponent?: Component;
    component: Component;
}
export interface FormElementSection {
    title: string;
    description?: string;
    elements: FormElementItem[];
    component?: Component;
}
export interface FormElement {
    sets: FormElementSection[];
}
export interface CommonFieldData {
    isReadOnly?: <T>(model: FormElementDataType<T>) => boolean;
    isHidden?: <T>(model: FormElementDataType<T>) => boolean;
    validation?: <T>(model: FormElementDataType<T>) => ValidationArgs;
    mandatory?: boolean;
}
export type FormElementError = {
    [key: string]: {
        [key: string]: string;
    };
};
